# Linux

## Introduction

The second day was a change for us, we have been surprised that we will use Linux for the course. I have tried Linux before, but for a few days only and then returned back to windows. I had three options, the first one is to install it using a virtual machine, the second option is to run Linux live from a USB flash drive and the last option is to download it as the second operating system beside my windows.

#### Installing Ubuntu

I have tried the first option, but I have not got that feeling of using Linux. I have not thought about the second option since that any work will be lost after shutting down the computer so I have downloaded it as my second operating system. After the first boot I got a boot problem, I could not boot into windows. The error was "can not find fwsetup", but I have repaired it using boot-repair in Linux terminal.

#### Basic commands

During this day, I have learned few Linux commands like `cd` to change directory, `mkdir` to make a directoy, `touch` to make a file, `nano` to edit the file. I have also learned how to download a software using the command `sudo apt install softwarename`, and have downloaded atom.  

Another useful commands are `head filename` to show the first 10 lines of the file content, `tail filename` to show the last 10 lines, `grep -rin "text"` to look for a text and `man command` to see the manual of a specific command.

## markdown to html

Writing the documentation using **nano** and **atom** is easier and faster than **html**. html has a lot of tags to remember whereas markdown allowed me to focus more on the content rather than the code, but web pages don't support markdown format so I had to learn how to convert `.md` to `.html` which is very easy to do using `pandoc` command in the terminal.

In the terminal, I have wrote those two command `sudo apt-get install haskell-platform` then `sudo apt-get install pandoc`. Fortunatly, I have not countered any issues.

**pandoc** is not a GUI program, instead it can be used in the terminal using the command which converts the markdown file to html file `pandoc -s -t html filename.md -o newfilename.html`

#### CSS

HTML does not includes tags for the web page format. markdown solved the problem of html tags for writing the content, but it can not be used to format the web page so I have used CSS to make the documentation looks more organized.

It is easy to include CSS in the html file, first thing I did is creating the styles.css file using `touch styles.css` in the terminal then I have copied the CSS code from [this link](http://git.fabcloud.io/francisco/beach-lab-htgaa-2015/raw/master/students/sanchez.francisco/base.css) to the styles.css using atom. The file is now ready, to include it in the html file, pandoc comman is changed to `pandoc -s -t html -c styles.css filename.md -o newfilename.html`.

The name **styles.css** it's self can be set to any other names, but the **.css** is a must.

## Git repository

I have heard about github, but never used it or read about how does it works. Prefab academy has introduced the concept of repository to me, and allowed me to learn the technology behind git.

#### signing up

First I did to start a git repository is sign up at [fablabs.io](http://fablabs.io) then I have logged in using my FabLab account at [gitlab.fabcloud.org](https://gitlab.fabcloud.org/). My instructor Mr.Fran has already created a project for the prefab course so he added me as a developer to the project. This repository allows me to upload my updates and contribution to the course website and to download my classmates updates.

#### setting up my computer

After signing up and being added to the course repository, I have cloned the repository address using **https** method by the command `git clone address`, the address can be found in [gitlab.fabcloud](https://gitlab.fabcloud.org/) then I have configure my computer using the following commands:

 `cd ~/folder_name # replace this with your repository folder`        

`git config --global user.name "yourname" #set name for commits`

`git config --global user.email "youremail" #set email for commits`

#### Uploading and Downloading

now that I have downloaded the repository folder and configured my computer, it is time to start adding and updating my section in the course website. To do it there are three steps. First one is to staging which is done using the command `git add --all`, then the next step is commit by the command `git commit -m "message"` and the last step is to push which is the step of uploading the files into the internet using the command `git push`. Since I have cloned using the https method, the push process requires my FabLab username and password. The password for the FabLab account can't be used, instead I have set up a new password as the gitlabs.fabcloud asked me to do the first time I have logged in.

The first time I have pushed, I got an error which states that I am not able to upload to protected content, the problem was solved by the admin Mr.Fran by changing my account from developer to master.

To download update the command `git pull` is used. It is important to pull before any push. `git status` is a very useful command. It is used to get the current status whether it is staging, commit or none of them.  

#### push using SSH

I found it unpractical to keep writing my username and password each time I want to push, so I have changed my push method to **SSH**. To do it, first thing I did is creating a hidden file in the home directory by the command `touch .ssh` then I have opened the file by the command `cd .ssh`. Now that my file is ready, I have generated the ssh key by the command `ssh-keygen -t rsa`, when it asks for the file, I have gave it the name prefab as shown in the image below

![](images/1.jpg)

Then I have pressed Enter two time to not set up a password for the keys. Finally I got my key in two files, one contains the public key and the other contains the private key. I have opened the file prefab.pub and copied the public key and paste it in the ssh set up page in the gitlabs.fabclouds and filled up the empty fields. Never share the private key, if the private key is compromised delete the the public key and generate a new key pair.  

Last step I did is to change the push method to ssh . I have changed the directory and opened the git repository by the command `cd "directory"`. Next thing I did, then I have changed the push method by the following command `git remote set-url origin "SSH Address"`, SSH Address can be found in the gitlabs.fabcloud website. the ssh key by the following commands.  

#### More git commands

push can not be revised, once the files are uploaded to the repository any one can pull and download them, but the add and commit steps can be revised. add step can be revised by the command `git reset` and the commit step can be revised by the command `git --soft HEAD~`.

Another git commands:

- `git remote -v` used to know push method
- `ssh-add -l` used to list ssh identities.
- `git log` history of the repository
- `git init` Make file a repository
- `git --version` Check git version
- `touvh .gitignore` set up files to be ignored

#### Constraints

## Automating the commands

It is unpractical to convert each markdown file to html in a separate command and then make the add, commit and push commands again and agian, so I have automated the whole process by just one command. First thing I did was creating a **.sh** file called auto using the command `touch auto.ssh`, then I have opened the file using atom and wrote all the commands I need as shown in the following image

![](images/auto.jpg)

To run the file, I have just to type `sh auto.sh "message"`.

## Manipulate images

All the images have a big size and high resolution, this is a problem when it comes to the documentation because the image should be less than 100KB in size so I have to edit the images before uploading them. To solve I have downloaded a tool called graphicsmagick using the following commands:
`sudo add-apt-repository ppa:rwky/graphicsmagick`  
`sudo apt-get update`                   
`sudo apt-get install graphicsmagick`

graphicsmagick can be used in the terminal, I have used this tool to put 3 images beside each other in one imge. This allowed me to resize the images and get the resolution I need. The following command can be used
`gm convert +append -geometry x400 imagename.format newimagename.format`
